# wmf - Waffle's Multipackage Framework

[![build status](https://development.crix-dev.com/ci/projects/3/status.png?ref=master)](https://development.crix-dev.com/ci/projects/3?ref=master) [![documentation status](http://v-rp.co/wmf/badge.svg)](http://v-rp.co/wmf/badge.svg)

wmf is supposed to give scripters the ability to work with multiple packages at the same time. This allows for a better code structure and readability. wmf is using ES6. You can find the docs at [this page](http://ruken.pw/wmf/) or [this repository](https://development.crix-dev.com/wmf/docs/tree/master).

## Installation

1. `npm install wmf` in your GTA:MP root directory
2. import it via `'../../node_modules/wmf'` from your packages.
_Note: you can also include the module in every package and just import it as `'wmf'`_

## Example Package

A proper example package can be found [on GitLab](https://development.crix-dev.com/wmf/wmf-examples).
```
// main.js
/**
 * @overview WMF Test Package
 * @author Jan "Waffle" Christophersen
 * @copyright (c) Jan "Waffle" Christophersen
 */
import WMF from '../../node_modules/wmf';

/**
 * The TestPackage, as the name suggests, solely exists for testing purposes.
 */
export default class TestPackage extends WMF.Package {
  /**
   * Creates the TestPackage.
   */
  constructor() {
    // super call must always be the directory name of this package.
    super('test');
  }

  /**
   * Initializes the package.
   */
  init() {
    log.info('hello there :-)');

    // access other packages via wmf.*
    // other packages can access this package via wmf.test
    super.init();
  }

  /**
   * Returns the package's dependencies.
   *
   * @type {Array.<string>}
   */
  get dependencies() {
    //return ['test2'];
    return [];
  }
}

// wmfPackage is now the global variable to get a handle to this package from any included file.
global.wmfPackage = new TestPackage();
```